/*
 * MIPS_ATOMIC_SET asm implementation for ll/sc capable cpus
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 2001 Florian Lohoff <flo@rfc822.org>
 *
 */
#include <linux/config.h>
#include <asm/asm.h>
#include <asm/mipsregs.h>
#include <asm/regdef.h>
#include <asm/stackframe.h>
#include <asm/isadep.h>
#include <asm/unistd.h>
#include <asm/sysmips.h>
#include <asm/offset.h>
#include <asm/errno.h>

#define PT_TRACESYS     0x00000002

	EXPORT(fast_sysmips)

	.set	noreorder

#if defined(CONFIG_CPU_HAS_LLSC)
       li      t0, MIPS_ATOMIC_SET
       beq     a0, t0, 1f
       nop
#else
       j       sys_sysmips
       nop
#endif

#if defined(CONFIG_CPU_HAS_LLSC)
1:

	# a0 - MIPS_ATOMIC_SET
	# a1 - mem ptr
	# a2 - value

	addiu	sp, sp, -8			# Reserve space
	sw	a0, (sp)			# Save arg0

	addiu	a0, a1, 4			# addr+size
	ori	v0, a1, 4			# addr | size
	lw	v1, THREAD_CURDS(gp)		# current->thread.current_ds
	or	v0, v0, a0			# addr | size | (addr+size)
	and	v1, v1, v0			# (mask)&(addr | size | (addr+size)
	bltz	v1, 5f
	 nop

2:
	ll	v0, (a1)
	move	t0, a2
	sc	t0, (a1)
	beqz	t0, 2b
	 nop

	sw	v0, PT_R2+8(sp)			# Result value
	sw	zero, PT_R7+8(sp)		# Success indicator

	lw      t0, TASK_PTRACE(gp)		# syscall tracing enabled?
	andi    t0, PT_TRACESYS
	bnez    t0, 3f
	 nop

4:
	lw	a0, (sp)			# Restore arg0
	addiu	sp, sp, 8			# Restore sp

	j	o32_ret_from_sys_call
	 nop

3:
	sw	ra, 4(sp)
	jal	syscall_trace
	 nop
	lw	ra, 4(sp)
	j	4b
	 nop

5:
	lw	a0, (sp)			# Restore arg0
	addiu	sp, sp, 8			# Restore sp
	j	ra
	 li	v0, -EFAULT

#endif
