/*
 * Registers for the DS1743 real-time-clock
 */

#ifndef _PPC_DS1743_H
#define _PPC_DS1743_H

#define RTC_ALWAYS_BCD 1	/* RTC operates in binary mode */

/* RTC Offsets */

#define DS1743_RTC_YEAR				0x1FFF
#define DS1743_RTC_MONTH			0x1FFE
#define DS1743_RTC_DAY_OF_MONTH		0x1FFD
#define DS1743_RTC_DAY_OF_WEEK		0x1FFC
#define DS1743_RTC_HOURS			0x1FFB
#define DS1743_RTC_MINUTES			0x1FFA
#define DS1743_RTC_SECONDS			0x1FF9
#define DS1743_RTC_CENTURY			0x1FF8
#define DS1743_RTC_CONTROL			0x1FF8

#define DS1743_RTC_CA_WRITE			0x80
#define DS1743_RTC_CA_READ			0x40


#define DS1743_RTC_BATTERY_FLAG		0x80
#define DS1743_RTC_FREQ_TEST		0x40
#define DS1743_RTC_OSC_DISABLE		0x80

#ifndef BCD_TO_BIN
#define BCD_TO_BIN(val) ((val)=((val)&15) + ((val)>>4)*10)
#endif

#ifndef BIN_TO_BCD
#define BIN_TO_BCD(val) ((val)=(((val)/10)<<4) + (val)%10)
#endif

#endif /* _PPC_DS1743_H */
