/****************************************************************************
 *  ishoni Networks Confidential and Proprietary Copyright (c) 2000
 ****************************************************************************
 *  FILE:       cacheiBELib.h
 *
 *  ENGINEER:   Tai Yu
 *
 *  PROJECT:    ishoni Broadband Engines 
 *
 *  REQUIREMENTS and FEATURES:
 *
 *  Should provide a single cache line invalidate utility macro for 
 *  invalidating one cache line of 16 bytes.
 *
 *  FUNCTIONAL DESCRIPTION:
 *
 *  REFERENCES:  
 *
 *  COMPILER REQUIREMENT:  
 *  == Compiler Name ===  ====== Options & Notes ============================
 *
 *  RELEASE HISTORY: (latest on top)
 *  Rev   == Date ==  ========= Modification after first release ============
 *  1.0   2000-03-16    original release
 *
 ********** <Indent=4 Spaces> ***********************************************/
#define PHY_TO_VIRT_ADDR(x)  (((unsigned int)x < 0x10000000) ? (((unsigned int)x) | 0x80000000):(((unsigned int)x) | 0xb0000000)) 
#define VIRT_TO_PHY_ADDR(x)  (((unsigned int)x < 0xb0000000) ? (((unsigned int)x) & 0x7fffffff):(((unsigned int)x) & 0x1fffffff))

/* ========== Published API Prototyping Start ============================== */
void cacheLineInvalidate(                                                /*. */
void *addr);             /*. Address of memory location to begin invalidating*/
                         /*. 16 bytes of cache line                          */

void *cnvrtAddr2CachedArea(                                              /*. */
void *nonCachedAddr);    /*. non-cached address                               */

void *cnvrtAddr2NonCachedArea(                                           /*. */
void *cachedAddr);      /*. non-cached address                               */


void *cnvrtAddrVirt2Phy(                                                 /*. */
void *addr);            /*. non-cached address                               */

void *cnvrtAddrPhy2Virt(                                                 /*. */
void *addr);            /*. non-cached address                               */

void invalidateCache(                                                    /*. */
void *addr,          /*. Address of memory location to begin invalidating    */
unsigned int numBytes);

/* ========== Published API Prototyping End   ============================== */
