#ifndef DRV_HOST_H
#define DRV_HOST_H
/****************************************************************************
 *  ishoni Networks Confidential and Proprietary Copyright (c) 2000
 ****************************************************************************
 *  FILE:  <filename>
 *
 *  ENGINEER:  <name of the responsible person>
 *
 *  PROJECT:  <project name> 
 *
 *  DESCRIPTION:
 *	<Who should include this file?>
 *
 *	RULES:
 *	 1. Contains only symbols and defines MUST be shared between files.
 *	 2. Source code and data storage are not allowed in this file
 *
 ********** <Indent=4 Spaces> ***********************************************/

#define  HOST_TIME_UPDATE    1    /*update HOST time value                   */

/* Definitions for HOST I/F device types */
#define INTEL_NON_MUXED                     0
#define INTEL_MUXED                         1
#define MOTOROLA_NON_MUXED                  2
#define MOTOROLA_MUXED                      3
#define ALCATEL_INTEL_COMPATIBLE            4
#define ALCATEL_MOTOROLA_COMPATIBLE         6


/* Definitions for HOST I/F interrupt mask bits */
#define UART_INT_ACTIVE                     0           
#define CMD_DONE_INT_BIT               0x0001
#define UART0_INT_BIT                  0x0002
#define UART1_INT_BIT                  0x0004
#define UART2_INT_BIT                  0x0008
#define EXTDEV3_INT_BIT                0x0010
#define EXTDEV4_INT_BIT                0x0020
#define EXTDEV5_INT_BIT                0x0040
#define EXTDEV6_INT_BIT                0x0080
#define BAUD_RATE_CNTR0_INT_BIT        0x0200
#define BAUD_RATE_CNTR1_INT_BIT        0x0400
#define BAUD_RATE_CNTR2_INT_BIT        0x0800
#define INT_BIT_MASK                   0x0fff


/* ========== Published API Prototyping Start ============================== */
int  enableHostIntBit(                                                   /*. */
unsigned short bits);     /*.see definitions for HOST I/F interrupt mask     */
                          /*.bits in drv_host.h for valid inputs.            */

int disableHostIntBit(                                                   /*. */
unsigned short bits);     /*.see definitions for HOST I/F interrupt mask     */
                          /*.bits in drv_host.h for valid inputs.            */

void enableUART_HostInt(                                                 /*. */
int port);                /*. port number 0,1,2                              */

void disableUART_HostInt(                                                /*. */
int port);                /*. port number 0,1,2 */

void regDevWithHostInterface(                                             /*. */
unsigned int slaveDevAddr,/*. Base address of slave device.  This address is  */
                          /*. determined by the chip select signal that the   */
                          /*. device is connected to.                         */
unsigned short devMode,   /*. Device type: please see definitions for HOST I/F*/
                          /*. device types in drv_host.h for valid inputs.    */
unsigned int timingParam0,/*. TimingParams : in number of system clock cycles.*/
unsigned int timingParam1,/*. 0: use defaults                                 */
unsigned int timingParam2,/*. other: please refer to the "iBE Device Register */
unsigned int timingParam3,/*. Timing Parameters" section in the Platform      */
unsigned int timingParam4,/*. Software Reference Manual for details on how to */
unsigned int timingParam5,/*. program the various timing parameters.          */
unsigned int timingParam6,/*.                                                 */
void (*slaveDevIsr)(int reason),/*. call back function for the interrupt      */
                                /*. service routine called by the Host I/F    */
int key);                 /*. Value to be passed as an argument to slaveDevIsr*/

void outp(                                                               /*. */
unsigned int slaveDevAddr,  /*.Address of the slave device driven onto the   */
                            /*.HOST INTERFACE BUS.                           */
unsigned char slaveDevData);/*.data to be written into the slave Device      */

void outpw(                                                              /*. */
unsigned int slaveDevAddr,  /*.Address of the slave device driven onto the   */
                            /*.HOST INTERFACE BUS.                           */
unsigned short slaveDevData);/*.data to be written into the slave Device     */

unsigned char inp(                                                       /*. */
unsigned int slaveDevAddr); /*.Address of the slave device driven onto the   */
                            /*.HOST INTERFACE BUS.                           */

unsigned short inpw(                                                     /*. */
unsigned int slaveDevAddr); /*.Address of the slave device driven onto the   */
                            /*.HOST INTERFACE BUS.                           */

/* ========== Published API Prototyping End   ============================== */


#endif DRV_HOST_H
